# Doctrine 2 plugin

This is a plugin to add Doctrine 2 introspection to ZendHQ's ZRay.

## Tab Entities
 
The `Entities` tab displays information about entities used on the current page, as well as entity mappings. 
It exposes the following columns:

 - **Entity**: FCQN of the entity class
 - **Number Of Unique Entities**: How many unique objects of this entity exist
 - **Number Of Referenced Entities**: How many references exist for this entity

## Tab Queries

The `Queries` tab displays information about executed queries, and exposes the following columns:

 - **id**: Query number
 - **Query**: The executed query, along with any bound parameters
 - **Count**: The number of executions
 - **Cached**: The number of cached queries

Note: real queries are calculated as `Number - Cached`.

## Tab Events

The `Events` tab displays information about Doctrine 2 events emitted as part of `Symfony\Bridge\Doctrine` support.
It exposes the following columns:

 - **Event**: The event name
 - **Count**: The Number of occurrences
 - **Listeners**: Listener classes

## Tab Cache

The `Cache` tab displays information about Doctrine 2 caches, including which cache driver is used.
It exposes the following columns:

 - **Type**: The cache type
 - **Status**: Which cache driver is used
