<?php

/**
 * Sake
 *
 * @link      http://github.com/sandrokeil/Z-Ray-Doctrine2 for the canonical source repository
 * @copyright Copyright (c) 2015 Sandro Keil, additional copyrights as noted in the COPYRIGHT.md file
 * @license   http://github.com/sandrokeil/Z-Ray-Doctrine2/blob/master/LICENSE.txt New BSD License
 */

namespace ZRay;

if (!class_exists('ZRayPlugin', false)) {
    return;
}

require_once 'Doctrine.php';

$zrp = new \ZRayPlugin('doctrine2', true);

$doctrine = new \ZRay\Doctrine();

$traces = [
    /** Doctrine\DBAL*/
    ['Doctrine\DBAL\Connection::executeUpdate', null, [$doctrine, 'connection']],
    ['Doctrine\DBAL\Connection::executeQuery', null, [$doctrine, 'connection']],
    ['Doctrine\DBAL\Connection::executeCacheQuery', null, [$doctrine, 'connection']],
    ['Doctrine\DBAL\Connection::beginTransaction', null, [$doctrine, 'transaction']],
    ['Doctrine\DBAL\Connection::commit', null, [$doctrine, 'transaction']],
    ['Doctrine\DBAL\Connection::rollback', null, [$doctrine, 'transaction']],
    ['Doctrine\DBAL\Statement::execute', [$doctrine, 'statement'], null],

    /** Doctrine Cache */
    ['Doctrine\ORM\Configuration::setSecondLevelCacheEnabled', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::getSecondLevelCacheConfiguration', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::setMetadataCache', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::getMetadataCache', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::setQueryCache', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::getQueryCache', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::setHydrationCache', null, [$doctrine, 'cache']],
    ['Doctrine\ORM\Configuration::getHydrationCache', null, [$doctrine, 'cache']],
    ['Doctrine\DBAL\Configuration::setResultCache', null, [$doctrine, 'cache']],
    ['Doctrine\DBAL\Configuration::getResultCache', null, [$doctrine, 'cache']],

    /** Doctrine ORM */
    ['Doctrine\ORM\UnitOfWork::createEntity', null, [$doctrine, 'unitOfWork']],
    ['Doctrine\ORM\UnitOfWork::__construct', null, [$doctrine, 'entityMapping']],

    /** Doctrine\Common\EventManager */
    ['Doctrine\Common\EventManager::dispatchEvent', null, [$doctrine, 'eventManagerDispatch']],
    ['Symfony\Bridge\Doctrine\ContainerAwareEventManager::dispatchEvent', null, [$doctrine, 'eventManagerDispatch']],
    ['Doctrine\Common\EventManager::addEventListener', null, [$doctrine, 'eventManagerAddListener']],
    ['Symfony\Bridge\Doctrine\ContainerAwareEventManager::addEventListener', null,
        [$doctrine, 'eventManagerAddListener']],

    /** Collect all data */
    ['ZRay\Doctrine::shutdown', null, [$doctrine, 'collectAllData']],
];

foreach ($traces as $trace) {
    $zrp->traceFunction($trace[0], $trace[1], $trace[2]);
}

// shutdown function to collect all data
register_shutdown_function([$doctrine, 'shutdown']);
