<?php
namespace ZRay\Wordpress;

class Plugins
{
	public function beforeExit(&$storage)
	{
		$wpPlugins = [];
		try {
			if (!function_exists('get_plugins')) {
				require_once ABSPATH . 'wp-admin/includes/plugin.php';
			}

			if (
				!defined('ABSPATH')
				|| !defined('WP_PLUGIN_DIR')
				|| !function_exists('get_plugins')
				|| !function_exists('get_mu_plugins')
				|| !function_exists('get_site_option')
			) {
				return;
			}

			$plugins = get_plugins();
			$activePlugins = [];

			if (count($plugins) > 0) {
				$apl = get_option('active_plugins');
				if (is_array($apl)) {
					foreach ($apl as $p) {
						if (isset($plugins[$p])) {
							array_push($activePlugins, $p);
						}
					}
				}
				//Multisite plugins
				$mupl = get_mu_plugins();
				if (is_array($mupl)) {
					foreach ($mupl as $p => $v) {
						$plugins[$p] = $v;
						array_push($activePlugins, $p);
					}
				}

				$swplugs = get_site_option('active_sitewide_plugins');
				if (is_array($swplugs)) {
					foreach ($swplugs as $p => $v) {
						if (isset($plugins[$p])) {
							array_push($activePlugins, $p);
						}
					}
				}
				foreach ($plugins as $p => $plugin) {
					$wpPlugins[] = [
						'Name' => $plugin['Name'],
						'Version' => $plugin['Version'],
						'State' => in_array($p, $activePlugins) ? 'Active' : 'Inactive',
						'Path' => $p,
						// 'loadtime' => '0'
					];
				}
			}
		} catch (\Exception $e) {
		}

		$storage['Plugins'] = $wpPlugins;

		$storage['Info'][0]['Plugins Directory'] = str_replace(DIRECTORY_SEPARATOR, '/', realpath(WP_PLUGIN_DIR));
		$storage['Info'][0]['Plugins Count'] = count($wpPlugins);
	}
}